/*
 * This file is part of play-clojurescript.
 * 
 * Copyright (c) 2013 Joachim Hofer
 * All rights reserved.
 *
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package de.johoop.play.plugin.clojurescript

import sbt._
import sbt.Keys._
import play.Project._

object ClojureScriptPlugin extends Plugin {
  val id = "play-clojurescript"
  val clojureScriptEntryPoints = SettingKey[PathFinder](id + "-entry-points")
  val clojureScriptOptions = SettingKey[Seq[String]](id + "-options")
  
  val ClojureScriptWatcher = AssetsCompiler(id,
    (_ ** "*.cljs"),
    clojureScriptEntryPoints in Compile,
    { (name, min) => name.replace(".cljs", if (min) ".min.js" else ".js") },
    { ClojureScriptCompiler.compile _ },
    clojureScriptOptions in Compile
  )

  override val settings = Seq(
    clojureScriptEntryPoints <<= (sourceDirectory in Compile).apply(base => ((base / "assets" ** "*.cljs") --- base / "assets" ** "_*")),
    clojureScriptOptions := Seq.empty[String],
    resourceGenerators in Compile <+= ClojureScriptWatcher
  )
}
